//  This file is part of jdl_parser.
//
//  jdl_parser is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  jdl_parser is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with jdl_parser.  If not, see <http://www.gnu.org/licenses/>.

// Copyright Simone Pellegrini 2007-2008; e-mail: motonacciu@gmail.com

#include "utils.hpp"

using namespace jdl;

std::pair<int, int> jdl::iter2RowCol(std::string const& str, std::string const& where){
	int rows = 1, cols = 1;
	string::const_iterator it = str.begin();
	string::const_iterator end = search(str.begin(), str.end(), where.begin(), where.end());
	while(it != end){
		if(*(it++) == '\n'){
			rows++;
			cols=0;
		}
		cols++;
	}
	return pair<int,int>(rows,cols);
}

void jdl::indent(int n, ostream& out){ 
	for(int i=0; i<n; i++)	
		out << "\t"; 
}

string jdl::open_file(const string& file_name){
	std::ifstream jdl_file(file_name.c_str());
	std::string s;
	std::string jdl_def = "";
	if(std::getline(jdl_file, s)){
		jdl_def += s;
		while (std::getline(jdl_file, s)) 
			jdl_def += "\n" + s;
	}
	return jdl_def;
}

