//  This file is part of jdl_parser.
//
//  jdl_parser is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  jdl_parser is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with jdl_parser.  If not, see <http://www.gnu.org/licenses/>.

// Copyright Simone Pellegrini 2007-2008; e-mail: motonacciu@gmail.com

#ifndef JDLPARSER_UTILS_HPP_
#define JDLPARSER_UTILS_HPP_

#include "defs.hpp"

namespace jdl{

class semantic_error: public logic_error{
public:
	semantic_error(string message): logic_error(message), where(NULL){};
	semantic_error(string message, char const *end): logic_error(message), where(end){};
	char const *where;
};

class parse_error: public logic_error{
public:
	parse_error(string message_, int row_, int col_): logic_error(message_), row(row_), col(col_){}
	const int row;
	const int col;
};

void indent(int n, ostream &out);

string open_file(string const& jdl_file);

std::pair<int, int> iter2RowCol(string const& str, string const& where);

}

#endif /*UTILS_HPP_*/
